# -*- coding: utf-8 -*-
"""Untitled0.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1hVHK1nSAE_xRpcW0-Ewa0_l3tE-n-St1
"""

#pip install

!pip install spotipy
!pip install requests
!pip install ffmpeg-python

#imports all necesary libraries

import os
import pathlib

import matplotlib.pyplot as plt
import numpy as np
import seaborn as sns
import tensorflow as tf

from tensorflow.keras import layers
from tensorflow.keras import models
from IPython import display

import spotipy
import requests
import ffmpeg
from spotipy.oauth2 import SpotifyClientCredentials

#define labels, create directories for them


labels=["AND", "ARG", "CNT", "CST", "CAT", "EUS", "EXT", "GAL", "MUR"]


for i in range(len(labels)):
    os.makedirs(f"./dataset/{labels[i]}", exist_ok = True)

#print(labels)
tf.io.gfile.listdir("./dataset")

#delete everything from dataset

for i in range(len(labels)):
  with os.scandir(f"./dataset/{labels[i]}") as dir:
    for entry in dir:
      if entry.is_file():
        os.remove(entry.path)
    print(f"i'm done cleaning with {labels[i]}")

#populates folders

playlists_1 = [
  'spotify:playlist:0g9chalaXMP9USpmpZEGJz', #Andalucía
  'spotify:playlist:0AXDTUEj0x3XpTEs3wtopX', #Aragón
  'spotify:playlist:1UAlXpl95p13SbF5fIL11p', #Cantabria
  'spotify:playlist:1mVs1QcawuzRLTzRUYlvpo', #Castilla
  'spotify:playlist:6e7E0W73tEIifLd8mmyCgM', #Cataluña
  'spotify:playlist:1G5Ghd3QgIdXofXkmdUJdE', #Euskadi
  'spotify:playlist:1aJww2nS7k6sRXTDmc9gK7', #Extremadura
  'spotify:playlist:52ISErdLSxIEj9YMVGeDJP', #Galicia 
  'spotify:playlist:1hDjWUtNjhol9iOlJA1Dal'  #Murcia
]

playlists_2 = [
  'spotify:playlist:6A4RrjwPI0wkX9zXYOmUQ9', #Andalucía
  'spotify:playlist:5doCdZocTsgcCpg9VXmpbw', #Aragón
  'spotify:playlist:3l9NeWcFpHO9TZdCuEitrQ', #Cantabria
  'spotify:playlist:0NHDS558dSIFskxrOfPfIO', #Castilla
  'spotify:playlist:1HdJ21TtDyMDH9fTOA5a0s', #Cataluña
  'spotify:playlist:2nRGiRqtDXh1t8Uem31zck', #Euskadi
  'spotify:playlist:6WwDe36RPKqUg2331tIGu6', #Extremadura
  'spotify:playlist:1W6MALrudLORpIaontgC0F', #Galicia
  'spotify:playlist:7h6R3dyXLMjcbu9dFqOexk' #Murcia
]

playlists_3 = [
  'spotify:playlist:4m84qspKC38UZ9cH1ND6gr', #Andalucía
  'spotify:playlist:1rftNr9Kg0RD4pr7WzGdee', #Aragón
  'spotify:playlist:3B2PEWe7azkEiQIUq1k1WX', #Cantabria
  'spotify:playlist:60ubM69ktJZgfRJWlqldDz', #Castilla
  'spotify:playlist:7Cixm3bEanw5NB3MF2fszB', #Cataluña
  'spotify:playlist:6i7AJS1bEsQdatagVFiOJs', #Euskadi
  'spotify:playlist:1RCuPo2bkRYX71slATBaSs', #Extremadura
  'spotify:playlist:1qvxK8OYDXKkgeqpHSk9lT', #Galicia 
  'spotify:playlist:7buAs5B1l7XrPF5Q0S09e9' #Murcia
]

playlists = [playlists_1, playlists_2, playlists_3]

datasetsize=100

#these loops populate the folders with .wav files
#due to spotipy's limit of 100 songs per request, each playlist has at max
#100 songs, and the 'for' loops iterate through the different playlists 
#to populate each folder with 300 songs

#after discussion with supervisor, it was decided to not include my own credentials
#in the source code. New credentials can be generated by registering the project on
# https://developer.spotify.com/dashboard/applications
client_id=''
client_secret=''

spotify = spotipy.Spotify(client_credentials_manager=SpotifyClientCredentials(client_id=client_id, client_secret=client_secret))

for j in range(len(playlists)):
  for i in range(len(playlists[j])):
    results = spotify.playlist_tracks(playlists[j][i])
    for track in results['items'][:datasetsize]:
        filename = track["track"]["uri"]
        data_url = track["track"]["preview_url"]
        track_name = track["track"]["name"]
        if data_url is None:
          print(f"{track_name} is missing! oh no!!")
          continue
        response = requests.get(data_url)
        f = open(f"./dataset/{labels[i]}/{filename}.mp3", "wb")
        f.write(response.content)
        f.close()
        audio = ffmpeg.input(f"./dataset/{labels[i]}/{filename}.mp3")
        audio = ffmpeg.output(audio, f"./dataset/{labels[i]}/{filename}.wav")
        ffmpeg.run(audio)
    print(f"{labels[i]} has been downloaded ({j} iteration)")


for i in range(len(labels)):
  with os.scandir(f"./dataset/{labels[i]}") as dir:
    for entry in dir:
      if entry.name.endswith(".mp3"):
        os.remove(entry.path)

#checks size of the dataset

import os
number=0
for i in range(len(labels)):
  with os.scandir(f"./dataset/{labels[i]}") as dir:
    for entry in dir:
      number=number+1
  print(f"{labels[i]} has {number} songs")
  number=0

#populates list of filenames
import tensorflow as tf

filenames = tf.io.gfile.glob('./dataset/*/*')
filenames = tf.random.shuffle(filenames)

#splits dataset into train, test,

_percent80 = int(0.8 * len(filenames))
_percent10 = int(0.1 * len(filenames))
train_files = filenames[:_percent80]
val_files = filenames[_percent80 : _percent80 + _percent10]
test_files = filenames[-1 * _percent10 :]

print('Training set size', len(train_files))
print('Validation set size', len(val_files))
print('Test set size', len(test_files))

#functions

def decode_audio(audio_binary):
  audio, _ = tf.audio.decode_wav(audio_binary, desired_channels=1)
  return tf.squeeze(audio, axis=-1)

def get_label(file_path):
  parts = tf.strings.split(
      input=file_path,
      sep=os.path.sep)
  return parts[-2]

def get_waveform_and_label(filename):
  audio_binary = tf.io.read_file(filename)
  waveform = decode_audio(audio_binary)
  label = get_label(filename)
  return waveform, label

AUTOTUNE = tf.data.AUTOTUNE

files_ds = tf.data.Dataset.from_tensor_slices(train_files)

waveform_ds = files_ds.map(
    map_func=get_waveform_and_label,
    num_parallel_calls=AUTOTUNE)

def get_spectrogram(waveform):
  # Zero-padding for an audio waveform with less than 30 seconds, 
  #to ensure consistent audio length
  #661248 = the number of samples in 30 seconds of audio
  input_len = 661248
  waveform = waveform[:input_len]
  zero_padding = tf.zeros(
      [input_len] - tf.shape(waveform),
      dtype=tf.float32)
  waveform = tf.cast(waveform, dtype=tf.float32)
  equal_length = tf.concat([waveform, zero_padding], 0)

  # Convert the waveform to a spectrogram via a STFT.
  spectrogram = tf.signal.stft(
      equal_length, frame_length=255, frame_step=128)
  spectrogram = tf.abs(spectrogram)
  spectrogram = spectrogram[..., tf.newaxis]
  return spectrogram

def get_spectrogram_and_label_id(audio, label):
  spectrogram = get_spectrogram(audio)
  label_id = tf.argmax(label == labels)
  return spectrogram, label_id

spectrogram_ds = waveform_ds.map(
  map_func=get_spectrogram_and_label_id,
  num_parallel_calls=AUTOTUNE)

#the model

def preprocess_dataset(files):
  files_ds = tf.data.Dataset.from_tensor_slices(files)
  output_ds = files_ds.map(
      map_func=get_waveform_and_label,
      num_parallel_calls=AUTOTUNE)
  output_ds = output_ds.map(
      map_func=get_spectrogram_and_label_id,
      num_parallel_calls=AUTOTUNE)
  return output_ds

train_ds = spectrogram_ds
val_ds = preprocess_dataset(val_files)
test_ds = preprocess_dataset(test_files)

batch_size = 64
train_ds = train_ds.batch(batch_size)
val_ds = val_ds.batch(batch_size)

train_ds = train_ds.cache().prefetch(AUTOTUNE)
val_ds = val_ds.cache().prefetch(AUTOTUNE)

for spectrogram, _ in spectrogram_ds.take(1):
  input_shape = spectrogram.shape
print('Input shape:', input_shape)
num_labels = len(labels)

# Instantiate the `tf.keras.layers.Normalization` layer.
norm_layer = layers.Normalization()
# Fit the state of the layer to the spectrograms
# with `Normalization.adapt`.
norm_layer.adapt(data=spectrogram_ds.map(map_func=lambda spec, label: spec))

model = models.Sequential([
    layers.Input(shape=input_shape),
    # Downsample the input.
    layers.Resizing(32, 32),
    # Normalize.
    norm_layer,
    layers.Conv2D(32, 3, activation='relu'),
    layers.Conv2D(64, 3, activation='relu'),
    layers.MaxPooling2D(),
    layers.Dropout(0.25),
    layers.Flatten(),
    layers.Dense(128, activation='relu'),
    layers.Dropout(0.5),
    layers.Dense(num_labels),
])

model.summary()

model.compile(
    optimizer=tf.keras.optimizers.Adam(),
    loss=tf.keras.losses.SparseCategoricalCrossentropy(from_logits=True),
    metrics=['accuracy'],
)

EPOCHS = 9
history = model.fit(
    train_ds,
    validation_data=val_ds,
    epochs=EPOCHS,
    callbacks=tf.keras.callbacks.EarlyStopping(verbose=1, patience=2),
)

test_audio = []
test_labels = []

for audio, label in test_ds:
  test_audio.append(audio.numpy())
  test_labels.append(label.numpy())

test_audio = np.array(test_audio)
test_labels = np.array(test_labels)

y_pred = np.argmax(model.predict(test_audio), axis=1)
y_true = test_labels

test_acc = sum(y_pred == y_true) / len(y_true)
print(f'Test set accuracy: {test_acc:.0%}')

import seaborn as sns

confusion_mtx = tf.math.confusion_matrix(y_true, y_pred)
plt.figure(figsize=(10, 8))
sns.heatmap(confusion_mtx,
            xticklabels=labels,
            yticklabels=labels,
            annot=True, fmt='g')
plt.xlabel('Prediction')
plt.ylabel('Label')
plt.show()